﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Custom View class 
#Event: Click
#DesignerProperty: Key: isChecked, DisplayName: Checked, FieldType: boolean, DefaultValue: False, Description: Checked.
#DesignerProperty: Key: iosType, DisplayName: Switch Ios Type, FieldType: boolean, DefaultValue: False, Description: Checked.
#DesignerProperty: Key: CircleColor, DisplayName: Color Checked, FieldType: Color, DefaultValue: 0xFF44B692, Description: Color of circle selector.
#DesignerProperty: Key: ColorBackground, DisplayName: Background color, FieldType: Color, DefaultValue: 0xFFB9E0DC, Description: Color of circle selector.
#DesignerProperty: Key: DisableCircleColor, DisplayName: Color Unchecked, FieldType: Color, DefaultValue: 0xFFB64444, Description: Color of circle selector.
#DesignerProperty: Key: DisableColorBackground, DisplayName: Disable BackgroundColo, FieldType: Color, DefaultValue: 0xFFE0B9C2, Description: Color of circle selector.

Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private nBase as Panel
	Private Ball As Button
	Private Raggio,Disp As Double

	Public CircleColor As Int =  0xFF44B692
	Public DisableCircleColor As Int = 0xFFB64444
	Public ColorBackground As Int = 0xFFB9E0DC
	Public DisableColorBackground As Int = 0xFFE0B9C2
	
	Private isChecked As Boolean
	Public iosType As Boolean
	Public Tag As Object
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

'Don't call on code 
Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
    
	If Props.ContainsKey("isChecked") Then isChecked=Props.Get("isChecked") Else isChecked=False
	If Props.ContainsKey("iosType") Then iosType=Props.Get("iosType") Else iosType=False
	If Props.ContainsKey("CircleColor") Then CircleColor=Props.Get("CircleColor") Else CircleColor=0xFF000000
	If Props.ContainsKey("DisableCircleColor") Then DisableCircleColor=Props.Get("DisableCircleColor") Else DisableCircleColor=0xFFB64444
	If Props.ContainsKey("ColorBackground") Then ColorBackground=Props.Get("ColorBackground") Else ColorBackground=0xFFB9E0DC
	If Props.ContainsKey("DisableColorBackground") Then DisableColorBackground=Props.Get("DisableColorBackground") Else DisableColorBackground=0xFFE0B9C2

	Raggio=mBase.Width/1.7
	If Raggio>mBase.Height Then Raggio=mBase.Height
	
	mBase.SetBackgroundImage(SwitchGroud)
	nBase.Initialize("Ball")
	mBase.AddView(nBase,0,0,mBase.Width,mBase.Height)
	Ball.Initialize("Ball")
	Ball.SetBackgroundImage(SwitchBall)
	Disp=(mBase.Height-Raggio)/2
	If isChecked Then
		mBase.AddView(Ball,0dip,Disp,Raggio,Raggio)
	Else
		mBase.AddView(Ball,mBase.Width-Raggio,Disp,Raggio,Raggio)
	End If
End Sub

Public Sub AddToPanel(View As Panel,Left As Int, top As Int, width As Int, height As Int)
	mBase.Initialize("")
	View.AddView(mBase,Left,top,width,height)
    	
	Raggio=mBase.Width/1.7
	If Raggio>mBase.Height Then Raggio=mBase.Height
	
	mBase.SetBackgroundImage(SwitchGroud)
	Ball.Initialize("Ball")
	Ball.SetBackgroundImage(SwitchBall)
	Disp=(mBase.Height-Raggio)/2
	If isChecked Then
		mBase.AddView(Ball,0dip,Disp,Raggio,Raggio)
	Else
		mBase.AddView(Ball,mBase.Width-Raggio,Disp,Raggio,Raggio)
	End If

End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

public Sub setChecked(Value As Boolean)
	isChecked=Value

	If isChecked Then
		Ball.SetLayoutAnimated(200,0dip,Disp,Raggio,Raggio)
		mBase.SetBackgroundImage(SwitchGroud)
		Ball.SetBackgroundImage(SwitchBall)
	Else
		Ball.SetLayoutAnimated(200,mBase.Width-Raggio,Disp,Raggio,Raggio)
		mBase.SetBackgroundImage(SwitchGroud)
		Ball.SetBackgroundImage(SwitchBall)
	End If
End Sub

Public Sub getChecked As Boolean
	return isChecked
End Sub

private Sub Ball_Click
	isChecked=Not(isChecked)

	If isChecked Then
		Ball.SetLayoutAnimated(200,0dip,Disp,Raggio,Raggio)
		mBase.SetBackgroundImage(SwitchGroud)
		Ball.SetBackgroundImage(SwitchBall)
	Else
		Ball.SetLayoutAnimated(200,mBase.Width-Raggio,Disp,Raggio,Raggio)
		mBase.SetBackgroundImage(SwitchGroud)
		Ball.SetBackgroundImage(SwitchBall)
	End If
	
	If SubExists(CallBack,EventName & "_Click") Then CallSub(CallBack,EventName & "_Click")
End Sub

private Sub SwitchGroud As Bitmap
	Dim Bm As Bitmap
	Dim Can As Canvas
	Dim Rec1 As Rect
	Dim X As Double
	
	x=mBase.Width/2
	If x>mBase.Height Then x=mBase.Height
	If iosType=False Then X=x/1.3
	Bm.InitializeMutable(mBase.Width,mBase.Height)
	Can.Initialize2(Bm)
	'Can.DrawColor(Colors.Transparent)
	Rec1.Initialize(X/2,(mBase.Height-X)/2,mBase.Width-(X/2),(mBase.Height+X)/2)

	If isChecked Then
		Can.DrawCircle(X/2,mBase.Height/2,X/2,ColorBackground,True,0dip)
		Can.DrawCircle(X/2,mBase.Height/2,X/2,Colors.Black,False,1dip)
		Can.DrawCircle(mBase.Width-X/2,mBase.Height/2,X/2,ColorBackground,True,0dip)
		Can.DrawCircle(mBase.Width-X/2,mBase.Height/2,X/2,Colors.Black,False,1dip)
		Can.DrawRect(Rec1,ColorBackground,True,1dip)
		Can.DrawLine(X/2,(mBase.Height-X)/2,mBase.Width-(X/2),(mBase.Height-X)/2,Colors.Black,1dip)
		Can.DrawLine(X/2,(mBase.Height+X)/2,mBase.Width-(X/2),(mBase.Height+X)/2,Colors.Black,1dip)
	Else
		Can.DrawCircle(X/2,mBase.Height/2,X/2,DisableColorBackground,True,0dip)
		Can.DrawCircle(X/2,mBase.Height/2,X/2,Colors.Black,False,1dip)
		Can.DrawCircle(mBase.Width-X/2,mBase.Height/2,X/2,DisableColorBackground,True,0dip)
		Can.DrawCircle(mBase.Width-X/2,mBase.Height/2,X/2,Colors.Black,False,1dip)
		Can.DrawRect(Rec1,DisableColorBackground,True,1dip)
		Can.DrawLine(X/2,(mBase.Height-X)/2,mBase.Width-(X/2),(mBase.Height-X)/2,Colors.Black,1dip)
		Can.DrawLine(X/2,(mBase.Height+X)/2,mBase.Width-(X/2),(mBase.Height+X)/2,Colors.Black,1dip)
	End If
	
	Return Can.Bitmap
End Sub

private Sub SwitchBall As Bitmap
	Dim Bm As Bitmap
	Dim Can As Canvas
		
	Bm.InitializeMutable(Raggio*2,Raggio*2)
	Can.Initialize2(Bm)

	If isChecked Then
		Can.DrawCircle(Raggio,Raggio,Raggio,CircleColor,True,0dip)
		Can.DrawCircle(Raggio,Raggio,Raggio,Colors.Black,False,2dip)
	Else
		Can.DrawCircle(Raggio,Raggio,Raggio,DisableCircleColor,True,0dip)
		Can.DrawCircle(Raggio,Raggio,Raggio,Colors.Black,False,2dip)
	End If
	
	Return Can.Bitmap
End Sub